package de.killig.framebuffer;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;

import android.graphics.Bitmap;
import android.graphics.Color;
import android.util.Log;

public class Framebuffer {

	private static final String LOG_TAG = "Framebuffer";

	private int framebuffer, width, height;

	public Framebuffer(int framebuffer) throws IOException {
		if(framebuffer==-1) {
			for(framebuffer=0; framebuffer<256; framebuffer++) {
				Log.d(LOG_TAG, "framebuffer="+framebuffer);
				if(new File("/dev/graphics/fb"+framebuffer).canWrite()) break;
			}
		}
		this.framebuffer=framebuffer;
  	BufferedReader buf=new BufferedReader(new FileReader("/sys/class/graphics/fb"+framebuffer+"/virtual_size"));
  	String[] as=buf.readLine().split(",");
  	buf.close();
  	width=Integer.parseInt(as[0]);
  	height=Integer.parseInt(as[1]);
	}
	
	public Framebuffer() throws IOException {
		this(-1);
	}
	
	public int getWidth() {
		return width;
	}

	public int getHeight() {
		return height;
	}

  public Bitmap createBitmap() {
		return Bitmap.createBitmap(width, height, Bitmap.Config.RGB_565);
	}
	
  public void tranfer(Bitmap bitmap, boolean recycle) throws IOException { // <=8.8 MB
		OutputStream os=new FileOutputStream("/dev/graphics/fb"+framebuffer);
  	int WIDTH=bitmap.getWidth(), HEIGHT=bitmap.getHeight();
  	int dim=WIDTH*HEIGHT;
  	int[] pixels=new int[dim]; // +<=8.8 MB
  	bitmap.getPixels(pixels, 0, WIDTH, 0, 0, WIDTH, HEIGHT);
  	if(recycle) bitmap.recycle();
		byte[] buffer=new byte[dim*2];
		int co;
		for(int o=0; o<dim; o++) {
			co=((Color.red(pixels[o]) >> 3) << 11) | ((Color.green(pixels[o]) >> 2) << 5) | (Color.blue(pixels[o]) >> 3);
			buffer[o*2  ]=(byte)(co & 0xff);
			buffer[o*2+1]=(byte)(co >>> 8 );
		}
		os.write(buffer);
		os.close();
	}
}
