package de.killig.framebuffer;

import java.io.IOException;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore.Images.Media;
import android.util.Log;
import android.widget.TextView;

public class SendToFramebuffer extends Activity {
	
	@Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.main);
	}
	
	@Override
	protected void onResume() {
		super.onResume();
    TextView t=(TextView)findViewById(R.id.my_textview);
    Intent i=getIntent();
    t.setText("getDataString:"+i.getDataString()+"\n");
    t.append("getScheme:"+i.getScheme()+"\n");
    t.append("getType:"+i.getType()+"\n");
    t.append("getData:"+i.getData()+"\n");
    Bundle b=i.getExtras();
    String s=b.get(Intent.EXTRA_STREAM).toString();
    Log.d(this.getClass().getSimpleName(), "s="+s);
    t.append("EXTRA_STREAM:"+s+"\n");
    try {
    	Framebuffer fb=new Framebuffer();
      t.append("fb.getWidth():"+fb.getWidth()+"\n");
      t.append("fb.getHeight():"+fb.getHeight()+"\n");
      t.append("maxMemory="+Runtime.getRuntime().maxMemory()+"\n");
    	Bitmap bmf=Media.getBitmap(getContentResolver(), Uri.parse(s));
    	if(bmf!=null) {
	    	Bitmap bm=fb.createBitmap();
				Canvas c = new Canvas(bm);
				Drawable d=new BitmapDrawable(bmf);
				
				int width, height;
				float aspectRatioSrc=(float)bmf.getWidth()/(float)bmf.getHeight(); // 4/3=1.3
				float aspectRatioDst=(float)fb.getWidth()/(float)fb.getHeight(); // 15/9=1.6
				if(aspectRatioSrc<aspectRatioDst) {
					height=fb.getHeight();
					width=(int)((float)height*aspectRatioSrc);
				} else {
					width=fb.getWidth();
					height=(int)((float)width/aspectRatioSrc);
				}
				
				int left=(fb.getWidth()-width)/2;
				int top=(fb.getHeight()-height)/2;
				d.setBounds(left, top, left+width, top+height);
				d.draw(c);
    		
    		bmf.recycle();
   			fb.tranfer(bm, true);
   			finish();
    	}
    } catch (IOException e) {
    	e.printStackTrace();
    	t.append(e.toString());
    }
  }
}
